summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2006-06-03 09:03:19 +0000
committerJim Meyering <jim@meyering.net>2006-06-03 09:03:19 +0000
commit09024704ab00a40dc45f6f69454f688feb079700 (patch)
treee55095be38a284b2dc65f7e41e3f4916c2b20edf /tests
parentdb5756af292644961cdb22fb1282700b8d14e20a (diff)
downloadcoreutils-09024704ab00a40dc45f6f69454f688feb079700.tar.xz
Test for this:
Make `cp --link --no-dereference' work also on systems where the link system call cannot create a hard link to a symbolic link. * src/copy.c (copy_internal) [LINK_FOLLOWS_SYMLINKS]: Don't use the link syscall on a symlink when it would do the wrong thing. Based on the patch by Aurelien Jarno: <http://bugs.debian.org/329451>
Diffstat (limited to 'tests')
-rwxr-xr-xtests/cp/link-no-deref31
1 files changed, 31 insertions, 0 deletions
diff --git a/tests/cp/link-no-deref b/tests/cp/link-no-deref
new file mode 100755
index 000000000..75fc7afc4
--- /dev/null
+++ b/tests/cp/link-no-deref
@@ -0,0 +1,31 @@
+#!/bin/sh
+# Ensure that cp --link --no-dereference works properly
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+ln -s no-such-file dangling-slink || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# Prior to coreutils-6.0, this would fail on non-Linux kernels,
+# with link being applied to the dangling symlink.
+cp --link --no-dereference dangling-slink d2 || fail=1
+
+(exit $fail); exit $fail